#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "fmod.h"
#include "fmod_dsp.h"
#include "fmod_errors.h"

#include <math.h>

#include <QList>
#include <QLabel>
#include <QGraphicsScene>
#include <QGraphicsRectItem>
#include <QGraphicsEllipseItem>
#include <QRectF>
#include <QTimer>
#include <QTime>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void open_snd(QString snd_path);
    void update_status_bar(QString text);

    float min(float a, float b);

    void init_animation();

    FMOD_SYSTEM *system;
    FMOD_SOUND *snd1;
    FMOD_CHANNEL *channel;
    FMOD_RESULT result;

    QLabel* status_label;

    int spectrum_size;
    int radius;
    int bass_segments;
    int bass_segment;

    int guitar_segments;

    float pi;

    QGraphicsTextItem* text_time;
    QTime time;
    int time1;
    int time2;

    QList<QGraphicsEllipseItem*> ellipse_list1;
    QList<QGraphicsEllipseItem*> ellipse_list2;

    QList<QGraphicsRectItem*> rect_list1;
    QList<QGraphicsRectItem*> rect_list2;
    QList<QGraphicsRectItem*> rect_list3;

    QList<QGraphicsLineItem*> line_list1;
    QList<QGraphicsLineItem*> line_list2;

    QGraphicsEllipseItem* bass;
    QGraphicsRectItem* bass2;
    QGraphicsScene* spectrum_scene;
    QPainter* painter;

    float* spectrumarray;

    QTimer* timer;

public slots:
    void draw_animation();
    
private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
