#include "mainwindow.h"
#include "ui_mainwindow.h"
//#include <QtGui>
//#include <QtOpenGL>
//#include <QGLWidget>



MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
	//pre set UI params...
    ui->setupUi(this);
    channel = 0;
    status_label = new QLabel("Starting...");
    ui->statusBar->addWidget(status_label);

	//init global params
    pi = 3.14159265;

    spectrum_size = 4096;


	//BASS SETTINGS:
	bass_circle_radius = 50.0;
	bass_segments_radius_min = 2.0;
	bass_segments_radius_max = 5.0;
    bass_segments = 100;
 
    kick_segment = 17;
	kick_circle_radius;
	
	bass_amplifier = 10.0;
	kick_amplifier = 5.0;

	bass_treshold;
	kick_treshold;

	//GUITAR SETTINGS:
	guitar_circle_radius;
    guitar_segments_radius_min;
	guitar_segments_radius_max;
	guitar_segments = 160;

	guitar_amplifier;

	guitar_treshold;	

    //guitar_segments = 160;


	//init GUI components
    ui->graphicsView->setViewportUpdateMode(QGraphicsView::FullViewportUpdate);
    spectrum_scene = new QGraphicsScene();
    spectrum_scene->setBackgroundBrush(QBrush(QColor(255,255,255,255)));
    ui->graphicsView->setScene(spectrum_scene);
    ui->graphicsView->setRenderHints(QPainter::Antialiasing);


    bass = spectrum_scene->addEllipse(0,0,radius*2,radius*2,QPen(QColor(255,255,255,100)),QBrush(QColor(0,0,0,0)));

    text_time = spectrum_scene->addText("-",QFont("Arial",8,-1,false));
    text_time->setDefaultTextColor(QColor(255,255,255,255));

    time.start();

    time1 = time.elapsed();

    spectrumarray = new float[spectrum_size];





    for(int i = 0; i < bass_segments; i++){
        QGraphicsEllipseItem* ellipse;
        if(i == bass_segment){
            ellipse = spectrum_scene->addEllipse(0,0,4,4,QPen(QColor(255,0,0,255)),QBrush(QColor(0,0,0,0)));
        }
        else{
            ellipse = spectrum_scene->addEllipse(0,0,4,4,QPen(QColor(0,0,255,255)),QBrush(QColor(0,0,0,0)));
        }
        //pre calc stuff...
        float calc = ((float)(i))/((float)(bass_segments))*360.0*(pi/180.0);
        ellipse->setPos(sin(calc)*60.0 -2 , cos(calc)*60.0 -2);
        ellipse_list1.append(ellipse);
    }

    for(int i = 0; i < guitar_segments; i++){
        QGraphicsEllipseItem* ellipse;
        ellipse = spectrum_scene->addEllipse(0,0,4,4,QPen(QColor(0,255,0,255)),QBrush(QColor(0,0,0,0)));

        //pre calc stuff...
        float calc = ((float)(i))/((float)(bass_segments))*360.0*(pi/180.0);
        ellipse->setPos(sin(calc)*65.0 -2 , cos(calc)*65.0 -2);
        ellipse_list2.append(ellipse);
    }

    timer = new QTimer();
    //timer->setInterval(10);
    timer->setInterval(1);
    connect(timer,SIGNAL(timeout()),this,SLOT(draw_animation()));

    open_snd("E:/nichtmeineverdammtefp/spectre_pro/spectr/beast.mp3");
    //open_snd("D:/projects/spectr/show_me_the_way.mp3");
}

void MainWindow::update_status_bar(QString text){
    status_label->setText(text);
}

float MainWindow::min(float a, float b){
    if(a < b){
        return a;
    }
    return b;
}

void MainWindow::draw_animation(){
    //FMOD_DSP_FFT_WINDOW_BLACKMANHARRIS , FMOD_DSP_FFT_WINDOW_HAMMING, FMOD_DSP_FFT_WINDOW_RECT
    FMOD_Channel_GetSpectrum( channel, spectrumarray, spectrum_size, 0, FMOD_DSP_FFT_WINDOW_BLACKMANHARRIS);


/*
    //NORMAILZE PASS

    //get max
    float max = 0.0;
    for(int i = 0; i < 128; i++){
        if(spectrumarray[i] > max){
            max = spectrumarray[i];
        }
    }

    //normalize
    for(int i = 0; i < 128; i++){
        spectrumarray[i] = spectrumarray[i] / max;
    }
*/


    QSize size = ui->graphicsView->size();
    int size_y = size.height();
    int size_x = size.width();




    //FIRST RING OF RINGS
    float max1 = 0;
    for(int i = 0; i < bass_segments; i++){
        if(spectrumarray[i]>max1){
            max1 = spectrumarray[i];
        }
    }

    //bass->setPos(-radius,-radius);
    bass->setRect(-radius*(1.0+spectrumarray[bass_segment]*7.0),-radius*(1.0+spectrumarray[bass_segment]*7.0),
                  radius*2*(1.0+spectrumarray[bass_segment]*7.0),radius*2*(1.0+spectrumarray[bass_segment]*7.0));

    //bass->setPen(QColor(255*4*((spectrumarray[bass_segment])/1.0),255-255*4*((spectrumarray[bass_segment])/1.0),255-255*4*((spectrumarray[bass_segment])/1.0),255));
    bass->setPen(QColor(0,0,0,0));

    for(int i = 0; i < ellipse_list1.length(); i++){
        //pre calc stuff...
        float calc = ((float)(i))/((float)(ellipse_list1.length()-1))*360.0*(pi/180.0);
        float calc2;
        //if(spectrumarray[bass_segment]>0.095){
        if(spectrumarray[bass_segment]>0.06){
            calc2 = 93.0*(1.0+spectrumarray[i]*10.0)*(1.0+spectrumarray[bass_segment]*5.0);
            ellipse_list1.at(i)->setPen(QColor(0,0,255,255));
            ellipse_list1.at(i)->setRect(0,0,10,10);
            ellipse_list1.at(i)->setPos(sin(calc)*calc2 -5,
                                        cos(calc)*calc2 -5);
        }
        else{
            calc2 = 93.0*(1.0+spectrumarray[i]*10.0);
            ellipse_list1.at(i)->setPen(QColor(0,0,255,185));
            ellipse_list1.at(i)->setRect(0,0,4*(1.0+spectrumarray[i]*16.0),4*(1.0+spectrumarray[i]*16.0));
            ellipse_list1.at(i)->setPos(sin(calc)*calc2 -2*(1.0+spectrumarray[i]*8.0),
                                        cos(calc)*calc2 -2*(1.0+spectrumarray[i]*8.0));
        }

        //ellipse_list1.at(i)->setPen(QColor(255*2*((spectrumarray[i])/1.0),0,255,255));
    }


    //SECOND RING OF RINGS
    float max2 = 0;
    for(int i = bass_segments+60; i < bass_segments + guitar_segments+70; i++){
        if(spectrumarray[i]>max2){
            max2 = spectrumarray[i];
        }
    }

    for(int i = 0; i < ellipse_list2.length(); i++){
        //pre calc stuff...
        float calc = ((float)(i))/((float)(ellipse_list2.length()-1))*360.0*(pi/180.0);
        //float calc2 = 10.0*(1.0+spectrumarray[guitar_segments+70 + i]*125.0);
        float calc2 = 40.0*(1.0+spectrumarray[guitar_segments+70 + i]*55.0);
        ellipse_list2.at(i)->setPos(sin(calc)*calc2-2,
                                    cos(calc)*calc2-2);
        ellipse_list2.at(i)->setPen(QColor(255*4*((spectrumarray[guitar_segments+70 + i])/1.0),255,0,255));
    }


    time2 = time.elapsed();
    text_time->setPos(50,50);
    text_time->setPlainText(QString::number(time2-time1));
    time1 = time2;

}

void MainWindow::init_animation(){
    timer->start();
}

void MainWindow::open_snd(QString snd_path){

    //statusBar()->removeWidget(status_label);

    result = FMOD_System_Create(&system);
    if(result != FMOD_OK){
        qDebug("FMOD error 1! (%d) %s\n", result, FMOD_ErrorString(result));
    }

    result =FMOD_System_Init(system, 32 ,FMOD_INIT_NORMAL,0 );
    if(result != FMOD_OK){
        qDebug("FMOD error 2! (%d) %s\n", result, FMOD_ErrorString(result));
    }


    result = FMOD_System_CreateStream(system, snd_path.toUtf8() ,FMOD_SOFTWARE,0,&snd1 );
    if(result != FMOD_OK){
        qDebug("FMOD error 3! (%d) %s\n", result, FMOD_ErrorString(result));
    }


    result = FMOD_System_PlaySound(system,FMOD_CHANNEL_FREE, snd1, false, &channel );
    if(result != FMOD_OK){
        qDebug("FMOD error 4! (%d) %s\n", result, FMOD_ErrorString(result));
    }

    update_status_bar("<font color=\"green\">Playing</font>: " + snd_path.toUtf8());
    ui->statusBar->addWidget(status_label);
    init_animation();
}

MainWindow::~MainWindow()
{
    delete ui;
}
