#include "settings.h"
#include "ui_settings.h"

Settings::Settings(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Settings)
{
    ui->setupUi(this);
    connect(ui->bass_amplifier,SIGNAL(valueChanged(double)),this,SLOT(set_bass_amplifier_slot(double)));
    connect(ui->bass_radius,SIGNAL(valueChanged(double)),this,SLOT(set_bass_circle_radius_slot(double)));
    connect(ui->bass_segment_radius,SIGNAL(valueChanged(double)),this,SLOT(set_bass_segments_radius_min_slot(double)));
    connect(ui->bass_segment_radius_amplifier,SIGNAL(valueChanged(double)),this,SLOT(set_bass_segments_radius_amplifier_slot(double)));
    connect(ui->bass_treshold,SIGNAL(valueChanged(double)),this,SLOT(set_bass_treshold_slot(double)));

    connect(ui->guitar_amplifier,SIGNAL(valueChanged(double)),this,SLOT(set_guitar_amplifier_slot(double)));
    connect(ui->guitar_radius,SIGNAL(valueChanged(double)),this,SLOT(set_guitar_circle_radius_slot(double)));
    connect(ui->guitar_segment_radius,SIGNAL(valueChanged(double)),this,SLOT(set_guitar_segments_radius_min_slot(double)));
    connect(ui->guitar_segment_radius_amplifier,SIGNAL(valueChanged(double)),this,SLOT(set_guitar_segments_radius_amplifier_slot(double)));
    connect(ui->guitar_treshold,SIGNAL(valueChanged(double)),this,SLOT(set_guitar_treshold_slot(double)));

    connect(ui->kick_amplifier,SIGNAL(valueChanged(double)),this,SLOT(set_kick_amplifier_slot(double)));
    connect(ui->kick_segment,SIGNAL(valueChanged(int)),this,SLOT(set_kick_segment_slot(int)));
    connect(ui->kick_treshold,SIGNAL(valueChanged(double)),this,SLOT(set_kick_treshold_slot(double)));

}

Settings::~Settings()
{
    delete ui;
}

void Settings::set_bass_circle_radius_slot(double circle_radius){
    set_bass_circle_radius_signal(circle_radius);
}

void Settings::set_bass_segments_radius_min_slot(double segments_radius_min){
    set_bass_segments_radius_min_signal(segments_radius_min);
}

void Settings::set_bass_segments_radius_amplifier_slot(double segments_radius_amplifier){
    set_bass_segments_radius_amplifier_signal(segments_radius_amplifier);
}

void Settings::set_kick_segment_slot(int segment){
    set_kick_segment_signal(segment);
}

void Settings::set_kick_circle_radius_slot(double circle_radius){
    set_kick_circle_radius_signal(circle_radius);
}

void Settings::set_bass_amplifier_slot(double amplifier){
    set_bass_amplifier_signal(amplifier);
}

void Settings::set_kick_amplifier_slot(double amplifier){
    set_kick_amplifier_signal(amplifier);
}

void Settings::set_bass_treshold_slot(double treshold){
    set_bass_treshold_signal(treshold);
}

void Settings::set_kick_treshold_slot(double treshold){
    set_kick_treshold_signal(treshold);
}



void Settings::set_guitar_circle_radius_slot(double circle_radius){
    set_guitar_circle_radius_signal(circle_radius);
}

void Settings::set_guitar_segments_radius_min_slot(double segments_radius_min){
    set_guitar_segments_radius_min_signal(segments_radius_min);
}

void Settings::set_guitar_segments_radius_amplifier_slot(double segments_radius_amplifier){
    set_guitar_segments_radius_amplifier_signal(segments_radius_amplifier);
}

void Settings::set_guitar_amplifier_slot(double amplifier){
    set_guitar_amplifier_signal(amplifier);
}

void Settings::set_guitar_treshold_slot(double treshold){
    set_guitar_treshold_signal(treshold);
}


//SIGNALS
void set_bass_circle_radius_signal(qreal circle_radius){
}

void set_bass_segments_radius_min_signal(qreal segments_radius_min){
}

void set_bass_segments_radius_amplifier_signal(qreal segments_radius_amplifier){
}

void set_kick_segment_signal(int segment){
}

void set_kick_circle_radius_signal(qreal circle_radius){
}

void set_bass_amplifier_signal(qreal amplifier){
}

void set_kick_amplifier_signal(qreal amplifier){
}

void set_bass_treshold_signal(qreal treshold){
}

void set_kick_treshold_signal(qreal treshold){
}



void set_guitar_circle_radius_signal(qreal circle_radius){
}

void set_guitar_segments_radius_min_signal(qreal segments_radius_min){
}

void set_guitar_segments_radius_amplifier_signal(qreal segments_radius_amplifier){
}

void set_guitar_amplifier_signal(qreal amplifier){
}

void set_guitar_treshold_signal(qreal treshold){
}


