#ifndef SETTINGS_H
#define SETTINGS_H

#include <QWidget>

namespace Ui {
class Settings;
}

class Settings : public QWidget
{
    Q_OBJECT
    
public:
    explicit Settings(QWidget *parent = 0);
    ~Settings();
    Ui::Settings *ui;
signals:
    void set_bass_circle_radius_signal(qreal circle_radius);
    void set_bass_segments_radius_min_signal(qreal segments_radius_min);
    void set_bass_segments_radius_amplifier_signal(qreal segments_radius_amplifier);
    void set_kick_segment_signal(int segment);
    void set_kick_circle_radius_signal(qreal circle_radius);
    void set_bass_amplifier_signal(qreal amplifier);
    void set_kick_amplifier_signal(qreal amplifier);
    void set_bass_treshold_signal(qreal treshold);
    void set_kick_treshold_signal(qreal treshold);

    void set_guitar_circle_radius_signal(qreal circle_radius);
    void set_guitar_segments_radius_min_signal(qreal segments_radius_min);
    void set_guitar_segments_radius_amplifier_signal(qreal segments_radius_amplifier);
    void set_guitar_amplifier_signal(qreal amplifier);
    void set_guitar_treshold_signal(qreal treshold);

public slots:
    void set_bass_circle_radius_slot(double circle_radius);
    void set_bass_segments_radius_min_slot(double segments_radius_min);
    void set_bass_segments_radius_amplifier_slot(double segments_radius_amplifier);
    void set_kick_segment_slot(int segment);
    void set_kick_circle_radius_slot(double circle_radius);
    void set_bass_amplifier_slot(double amplifier);
    void set_kick_amplifier_slot(double amplifier);
    void set_bass_treshold_slot(double treshold);
    void set_kick_treshold_slot(double treshold);

    void set_guitar_circle_radius_slot(double circle_radius);
    void set_guitar_segments_radius_min_slot(double segments_radius_min);
    void set_guitar_segments_radius_amplifier_slot(double segments_radius_amplifier);
    void set_guitar_amplifier_slot(double amplifier);
    void set_guitar_treshold_slot(double treshold);
};

#endif // SETTINGS_H
